; >$.minix.usr.s.tstdrv
;
; Testmodul fuer den AOS-Minix-Treiber
;
; (C) 30/11/89 Martin Patzel
;


		ORG	&8000


		GET	$.arm.aslib.register
		GET	$.arm.aslib.arthur
		GET	$.arm.aslib.constants
		GET	$.arm.aslib.macros

		GET	h.aosdriver
		GET	h.asconst

		MACRO
$label		Wait	$r
$label		LDR	$r,=&100000
		SUBS	$r, $r, #1
		DCD	&CAFFFFFD	; Bra zur vorigen Zeile
		MEND


;==============================================================================
; start
;
; Hauptprogramm
;
; in  :	-
; out :	-
;==============================================================================
start
		InitMem
		InitSP	#&400
		InitMac


;==============================================================================
; Test: MX_Special
;==============================================================================
		MOV	R0, #SP_SetLeds
		MOV	R1, #4		; ein
		MOV	R2, #7		; alle
		SWI	MX_Special
		Wait	R0
		MOV	R0, #SP_SetLeds
		MOV	R1, #1		; aus
		MOV	R2, #1		; nur eine LED
		SWI	MX_Special
		Wait	R0
		MOV	R0, #SP_SetLeds
		MOV	R1, #3		; aus
		MOV	R2, #7		; alle
		SWI	MX_Special

		SWI	MX_EnterSVC
		MOV	R0, #IOC_BASE		; Timer 1 initialisieren
		LDRB	R1, [R0, #IOC_IRQAMASK]
		BIC	R1, R1, #&40		; Timer 1 Interrupt aus
		STRB	R1, [R0, #IOC_IRQAMASK]
		MOV	R1, #&FF
		STRB	R1, [R0, #IOC_T1LATCHL]
		STRB	R1, [R0, #IOC_T1LATCHH]
		STRB	R1, [R0, #IOC_T1GO]
		TEQP	PC, #UserMode

		MOV	R8, #10		; 10 loops...
		RPrint	"starting loops: ", R8

tim2		LDR	R0, timconst	; 1 Sekunde
		MOV	R7, R0		; # Ticks
		MOV	R0, #SP_ReadTimer
		SWI	MX_Special
		MOV	R6, R0		; Timerbeginn
tim1		MOV	R0, #SP_ReadTimer
		SWI	MX_Special
		SUBS	R1, R6, R0	; Timer laeuft rueckwaerts
		BIC	R1, R1, #&FF000000
		BIC	R1, R1, #&00FF0000
		MOV	R6, R0
		SUBS	R7, R7, R1
		BGT	tim1

		SUBS	R8, R8, #1
		RPrint	"loop: ", R8
		BGT	tim2


		SWI	OS_Exit


;
;============== DATA SECTION ==================================================
;

		ALIGN

macbuf		DCD	0
timconst	DCD	2000000		; 1 Sek bei 8MHz/4

end		EQU	.
		END
