#define	MAX_SWAP_SIZE	0x200000/* 2MB Swap space */
#define	MIN_PAGE_SIZE	0x1000	/* Pages are at least 4K big */

#define	MAX_PHYS_PAGES	128	/* Number of physical memory pages */
#define	MAX_SWAP_PAGES	(MAX_SWAP_SIZE/MIN_PAGE_SIZE)
#define MAX_PAGETABLES	NR_PROCS/* one per process */
#define	MAX_PT_ENTRIES	256	/* Max. number of pages per process */

#define BPBME		(sizeof(bitmap) * 8)	/* bits per bitmap entry */
#define	MEM_MAP_SIZE	(ALIGN_UP(MAX_PHYS_PAGES, BPBME)/(long)BPBME)
#define SWAP_MAP_SIZE	(ALIGN_UP(MAX_SWAP_PAGES, BPBME)/(long)BPBME)
#define PT_MAP_SIZE	(ALIGN_UP(MAX_PAGETABLES, BPBME)/(long)BPBME)

#define	PROTECT_FREE	0	/* Page protection levels */
#define	PROTECT_OS	1
#define	PROTECT_LOCKED	3

/* needed for systask: do_mem */
#define	SM_FREE_MEM	0
#define SM_FREE_CORE	1
#define	SM_ALLOC_RAMDISK 2

/* This are the bits used in one pagetable entry */
#define	PTE_SWAPPED	0x8000		/* page is swapped out */
#define	PTE_FREE	0x4000		/* page is unused, not mapped */
#define PTE_LOCKED	0x2000		/* page may not be swapped */
#define	PTE_PAGENUM	0x0FFF		/* the pagenumber itself */

typedef unsigned short pt_entry;
typedef pt_entry pagetable[MAX_PT_ENTRIES];
typedef unsigned long bitmap;	/* type holding map of free pages */
typedef short phys_pagenum;	/* type holding the physical pagenumbers */

typedef struct mem_info {
  vir_bytes	low_user;
  vir_bytes	high_user;
  vir_bytes	pagesize;
  int		free_mempg;
  int		free_swappg;
} mem_info;
