/* This process is used for starting up the real init process.
 * It does only a exec("/etc/init"). The kernel will distinguish this
 * special case and perform a special exec.
 * This one won't destroy the old image (this file) since it is
 * compiled into the kernel, but this exec will overwrite this
 * process' table entries.
 */

#include <minix/config.h>
#ifndef AM_KERNEL
#define AM_KERNEL	0
#endif
#include <minix/const.h>
#include <minix/type.h>
#include <minix/com.h>
#include <minix/callnr.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <syslib.h>


#define	STACKSIZE	512
#define	NARGS		2
#define MM		0

char init[] = "/etc/init";
char stack[STACKSIZE];		/* init's stack */
char *stackpt = &stack[STACKSIZE];
char *stacklow= &stack[0];


int
main()
{
  char *cp;
  char *stackframe[5 + (2*sizeof(init))/sizeof(char *)];
  union stacktypes {
  	int	*i;
  	char	**cp;
  	char	*c;
  } up;

  up.cp = stackframe;
  *up.i++  = NARGS;				/* argc */
  *up.cp++ = (char *)(sizeof(int) + (NARGS + 2) * sizeof(char *));
  *up.cp++ = (char *)(sizeof(int) + (NARGS + 2) * sizeof(char *) + sizeof(init));
  *up.cp++ = NULL;				/* end of arguments */
  *up.cp++ = NULL;				/* end of environment */
  strcpy(up.c, init); up.c += sizeof(init);
  strcpy(up.c, init); up.c += sizeof(init);
  callm1(MM, EXEC, strlen(init)+1, up.c-(char *)stackframe,
  	 0, init, (char *)stackframe, NIL_PTR);

  open("/dev/tty0", O_WRONLY);
  cp = "\r\npanic: init: can't find /etc/init.\r\nSystem halted.\r\n";
  write(0, cp, strlen(cp));

  while (1) ;	/* never return! */
}

