#include <stdarg.h>
#include <uart.h>

void _puts (const char *str) {

 while (*str != '\0') {
        putc( *str);
        *str++;
 }
}

char *
_i_compute(unsigned long val, int base, char *s, int nrdigits)
{
        int c;

        c= val % base ;
        val /= base ;
        if (val || nrdigits > 1)
                s = _i_compute(val, base, s, nrdigits - 1);
        *s++ = (c>9 ? c-10+'a' : c+'0');
        return s;
}

/*
 * Finds out the precision control of the val, in the 
 * base systme
 */
int
_find_precision( unsigned  long val, int base) {

  int ii = val;
  int jj;
  
  for (jj = 0; ii > 0; jj++)
	ii = (int) (ii / base);

  return jj;

}
   /* minprintf: minimal printf with variable argument list */
   void printf(char *fmt, ...)
   {
       va_list ap; /* points to each unnamed arg in turn */
       char *p, *sval;
       char buf[1024]; // Do we need that big? Probably not. 
       char *s;
	int base;
	int precision ;
	// Think about this latter on.
       int ival;
       double dval;
	s	 = buf;
       va_start(ap, fmt); /* make ap point to 1st unnamed arg */
       for (p = fmt; *p; p++) {
	   if (*p == '\n') {
		//putc('\n');
		putc('\r');
	   }
           if (*p != '%') {
               putc(*p);
               continue;

           }
           switch (*++p) {
           case 'd': 
	   case 'i':
	   case 'u': 
               ival = va_arg(ap, int); base = 10;
		// Base 10.
		precision = _find_precision(ival, base);
		buf[precision ] = '\0';
		s = _i_compute(ival, base, s, precision);
		_puts(buf);	
               break;
	   case 'x':
	   case 'X':
	   case 'p':
		ival = va_arg(ap, int);
		base = 16; precision = _find_precision(ival, base);
		// Base 16.
		buf[precision] = '\0';
		s = _i_compute(ival, base, s, precision);
		_puts(buf);
		break;
	   case 'b':
		ival = va_arg(ap, int);
		base = 2; precision = _find_precision(ival, base);
		s = _i_compute(ival, base, s, precision);
		buf[precision  ] = '\0';
		_puts(buf);
		// Base 2
		break;
	   case 'o':
		ival = va_arg(ap, int);
		// Base 8
		s = _i_compute(ival, 8, s, precision);
		buf[precision ] = '\0';
		_puts(buf);
		break;
           case 'f':
               dval = va_arg(ap, double);
		_puts("[float not supported]");
               break;
           case 's':
               for (sval = va_arg(ap, char *); *sval; sval++)
                   putc(*sval);
               break;
           default:
	       if ( *p == '\n') {
		putc('\n');
		putc('\r');
	       }
               putc(* p);
               break;
           }
       }
       va_end(ap); /* clean up when done */
   }
